ctdb-tests: Avoid shellcheck warning SC2045
[Samba.git] / ctdb / tests / run_tests.sh
blob27f9b1d18781903f868c71b144d2ae45a7404458
1 #!/usr/bin/env bash
3 usage() {
4 cat <<EOF
5 Usage: $0 [OPTIONS] [TESTS]
7 Options:
8 -A Use "cat -A" to print test output (only some tests)
9 -c Run integration tests on a cluster
10 -C Remove TEST_VAR_DIR when done
11 -d Print descriptions of tests instead of filenames (dodgy!)
12 -D Show diff between failed/expected test output (some tests only)
13 -e Exit on the first test failure
14 -H No headers - for running single test with other wrapper
15 -N Don't print summary of tests results after running all tests
16 -q Quiet - don't show tests being run (hint: use with -s)
17 -S <lib> Use socket wrapper library <lib> for local integration tests
18 -v Verbose - print test output for non-failures (only some tests)
19 -V <dir> Use <dir> as TEST_VAR_DIR
20 -x Trace this script with the -x option
21 -X Trace certain scripts run by tests using -x (only some tests)
22 EOF
23 exit 1
26 # Print a message and exit.
27 die ()
29 echo "$1" >&2 ; exit "${2:-1}"
32 ######################################################################
34 with_summary=true
35 with_desc=false
36 quiet=false
37 exit_on_fail=false
38 no_header=false
40 export TEST_VERBOSE=false
41 export TEST_COMMAND_TRACE=false
42 export TEST_CAT_RESULTS_OPTS=""
43 export TEST_DIFF_RESULTS=false
44 export TEST_LOCAL_DAEMONS
45 [ -n "$TEST_LOCAL_DAEMONS" ] || TEST_LOCAL_DAEMONS=3
46 export TEST_VAR_DIR=""
47 export TEST_CLEANUP=false
48 export TEST_TIMEOUT=3600
49 export TEST_SOCKET_WRAPPER_SO_PATH=""
51 while getopts "AcCdDehHNqS:T:vV:xX?" opt ; do
52 case "$opt" in
53 A) TEST_CAT_RESULTS_OPTS="-A" ;;
54 c) TEST_LOCAL_DAEMONS="" ;;
55 C) TEST_CLEANUP=true ;;
56 d) with_desc=true ;; # 4th line of output is description
57 D) TEST_DIFF_RESULTS=true ;;
58 e) exit_on_fail=true ;;
59 H) no_header=true ;;
60 N) with_summary=false ;;
61 q) quiet=true ;;
62 S) TEST_SOCKET_WRAPPER_SO_PATH="$OPTARG" ;;
63 T) TEST_TIMEOUT="$OPTARG" ;;
64 v) TEST_VERBOSE=true ;;
65 V) TEST_VAR_DIR="$OPTARG" ;;
66 x) set -x ;;
67 X) TEST_COMMAND_TRACE=true ;;
68 \?|h) usage ;;
69 esac
70 done
71 shift $((OPTIND - 1))
73 case $(basename "$0") in
74 *run_cluster_tests*)
75 # Running on a cluster... same as -c
76 TEST_LOCAL_DAEMONS=""
78 esac
80 if $quiet ; then
81 show_progress() { cat >/dev/null ; }
82 else
83 show_progress() { cat ; }
86 ######################################################################
88 ctdb_test_begin ()
90 local name="$1"
92 teststarttime=$(date '+%s')
93 testduration=0
95 echo "--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--"
96 echo "Running test $name ($(date '+%T'))"
97 echo "--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--"
100 ctdb_test_end ()
102 local name="$1" ; shift
103 local status="$1" ; shift
104 # "$@" is command-line
106 local interp="SKIPPED"
107 local statstr=" (reason $*)"
108 if [ -n "$status" ] ; then
109 if [ "$status" -eq 0 ] ; then
110 interp="PASSED"
111 statstr=""
112 echo "ALL OK: $*"
113 elif [ "$status" -eq 124 ] ; then
114 interp="TIMEOUT"
115 statstr=" (status $status)"
116 else
117 interp="FAILED"
118 statstr=" (status $status)"
122 testduration=$(($(date +%s) - teststarttime))
124 echo "=========================================================================="
125 echo "TEST ${interp}: ${name}${statstr} (duration: ${testduration}s)"
126 echo "=========================================================================="
130 ctdb_test_run ()
132 local name="$1" ; shift
134 [ -n "$1" ] || set -- "$name"
136 $no_header || ctdb_test_begin "$name"
138 local status=0
139 if [ -x "$1" ] ; then
140 timeout "$TEST_TIMEOUT" "$@" || status=$?
141 else
142 echo "TEST IS NOT EXECUTABLE"
143 status=1
146 $no_header || ctdb_test_end "$name" "$status" "$*"
148 return $status
151 ######################################################################
153 tests_total=0
154 tests_passed=0
155 tests_failed=0
157 if ! type mktemp >/dev/null 2>&1 ; then
158 # Not perfect, but it will do...
159 mktemp ()
161 local dir=false
162 if [ "$1" = "-d" ] ; then
163 dir=true
165 local t="${TMPDIR:-/tmp}/tmp.$$.$RANDOM"
167 umask 077
168 if $dir ; then
169 mkdir "$t"
170 else
171 : >"$t"
174 echo "$t"
178 tf=$(mktemp) || die "mktemp failed for tf - is TMPDIR missing?"
179 sf=$(mktemp) || die "mktemp failed for sf - is TMPDIR missing?"
181 set -o pipefail
183 run_one_test ()
185 local f="$1"
187 tests_total=$((tests_total + 1))
189 ctdb_test_run "$f" | tee "$tf" | show_progress
190 status=$?
191 if [ $status -eq 0 ] ; then
192 tests_passed=$((tests_passed + 1))
193 else
194 tests_failed=$((tests_failed + 1))
196 if $with_summary ; then
197 local t
198 if [ $status -eq 0 ] ; then
199 t=" PASSED "
200 else
201 t="*FAILED*"
203 if $with_desc ; then
204 desc=$(tail -n +4 "$tf" | head -n 1)
205 f="$desc"
207 echo "$t $f" >>"$sf"
211 find_and_run_one_test ()
213 local t="$1"
214 local dir="$2"
216 local f="${dir}${dir:+/}${t}"
218 if [ -d "$f" ] ; then
219 local i
220 for i in "${f%/}/"*".sh" ; do
221 # Only happens if test removed (unlikely) or empty directory
222 if [ ! -f "$i" ] ; then
223 break
225 run_one_test "$i"
226 if $exit_on_fail && [ $status -ne 0 ] ; then
227 break
229 done
230 # No tests found? Not a tests directory! Not found...
231 [ -n "$status" ] || status=127
232 elif [ -f "$f" ] ; then
233 run_one_test "$f"
234 else
235 status=127
239 export CTDB_TEST_MODE="yes"
241 # Following 2 lines may be modified by installation script
242 CTDB_TESTS_ARE_INSTALLED=false
243 CTDB_TEST_DIR=$(dirname "$0")
244 export CTDB_TESTS_ARE_INSTALLED CTDB_TEST_DIR
246 if [ -z "$TEST_VAR_DIR" ] ; then
247 if $CTDB_TESTS_ARE_INSTALLED ; then
248 TEST_VAR_DIR=$(mktemp -d)
249 else
250 TEST_VAR_DIR="${CTDB_TEST_DIR}/var"
253 mkdir -p "$TEST_VAR_DIR"
255 export TEST_SCRIPTS_DIR="${CTDB_TEST_DIR}/scripts"
257 unit_tests="
258 cunit
259 eventd
260 eventscripts
261 onnode
262 shellcheck
263 takeover
264 takeover_helper
265 tool
268 # If no tests specified then run some defaults
269 if [ -z "$1" ] ; then
270 if [ -n "$TEST_LOCAL_DAEMONS" ] ; then
271 set -- UNIT simple
272 else
273 set -- simple complex
277 do_cleanup ()
279 if $TEST_CLEANUP ; then
280 echo "Removing TEST_VAR_DIR=$TEST_VAR_DIR"
281 rm -rf "$TEST_VAR_DIR"
282 else
283 echo "Not cleaning up TEST_VAR_DIR=$TEST_VAR_DIR"
287 trap "do_cleanup ; exit 130" SIGINT
288 trap "do_cleanup ; exit 143" SIGTERM
290 declare -a tests
292 for f ; do
293 if [ "$f" = "UNIT" ] ; then
294 for t in $unit_tests ; do
295 tests[i++]="$t"
296 done
297 else
298 tests[i++]="$f"
300 done
302 for f in "${tests[@]}" ; do
303 find_and_run_one_test "$f"
305 if [ $status -eq 127 ] ; then
306 # Find the the top-level tests directory
307 d=$(cd "$TEST_SCRIPTS_DIR" && echo "$PWD")
308 if [ -z "$d" ] ; then
309 die "Unable to find TEST_SCRIPTS_DIR=\"${TEST_SCRIPTS_DIR}\""
311 tests_dir=$(dirname "$d")
312 # Strip off current directory from beginning, if there, just
313 # to make paths more friendly.
314 tests_dir=${tests_dir#$PWD/}
315 find_and_run_one_test "$f" "$tests_dir"
318 if [ $status -eq 127 ] ; then
319 die "test \"$f\" is not recognised"
322 if $exit_on_fail && [ $status -ne 0 ] ; then
323 break
325 done
327 rm -f "$tf"
329 if $with_summary ; then
330 echo
331 cat "$sf"
332 echo
333 echo "${tests_passed}/${tests_total} tests passed"
336 rm -f "$sf"
338 echo
340 do_cleanup
342 if $no_header || $exit_on_fail ; then
343 exit $status
344 elif [ $tests_failed -gt 0 ] ; then
345 exit 1
346 else
347 exit 0